
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/sockios.h>
#include <linux/if_ether.h>
#include <linux/if_arp.h>
#include <linux/if_packet.h>
#include <sys/time.h>
#include "dhcpc.h"

#define	RING_C

#include "packet.h"
#include <board.h>

typedef struct padi_packet 
{
	u_char Dst_e_hw[ETH_ALEN];
	u_char Src_e_hw[ETH_ALEN];
	u_short frame_type;
	
	u_char v_t;
	u_char code;
	u_short session_id;
	u_short len;
	u_short tag_type;
	u_short tag_len;
} __attribute__ ((packed)) PADI_PACKET;


typedef struct arp_packet
{
	u_char Dst_e_hw[ETH_ALEN];
	u_char Src_e_hw[ETH_ALEN];
	u_short frame_type;
	u_short hw_type;
	u_short prot_type;
	u_char hw_addr_size;
	u_char prot_addr_size;
	u_short op;
	u_char Src_a_hw[ETH_ALEN];
	u_char Src_a_ip[4];
	u_char Dst_a_hw[ETH_ALEN];
	u_char Dst_a_ip[4];
} __attribute__ ((packed)) ARP_PACKET;


void _die(char *str);
void get_hw_addr(char *buf, char *str);
//void SendArpPkt(char *dev, char *src_e_hw, char *dst_e_hw, int op, char *src_a_hw, char *src_a_ip, char *dst_a_hw, char *dst_a_ip);
int SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip);
void SendpadiPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw);
void savePtype(unsigned char ptype);
void usage();
int getdevindex(int sock, u_char *name);
int strip(unsigned char *dst, unsigned char *str);

void usage()
{
	FPRINTF(stderr, "* Usage : <dev> <SEmac> <DEmac> <Op> <SAmac> <Sip> <DAmac> <Dip> *\n"
					"* <dev> : Should we send the packet over something *\n"
					"* <SEmac> : source mac address for ethernet header *\n"
					"* <DEmac> : dest mac address for ethernet header *\n"
					"* <Op> : Opcode for arp header read my or cat if_arp.h *\n"
					"* <SAmac> : source mac address for arp header *\n"
					"* <Sip> : source ip address for arp header *\n"
					"* <DAmac> : dest mac address for arp header *\n"
					"* <Dip> : dest ip address for arp header *\n");
	exit(0);
}

void usage_pppoe()
{
	DPRINTF("Hello\n");
	FPRINTF(stderr, "* Usage : <dev> <SEmac> <DEmac> *\n"
					"* <dev> : Should we send the packet over something *\n");
	exit(0);
}

#ifdef	WIZARD
void main(int argc, u_char *argv[])
{
	int result = -1;
	
	result = wizard_go(argv[1]);
	printf("result = %d\n", result);
}
#endif

int arpReply = 0;
extern char spoof_mac[];
//extern char macstr[];
#define ADD_VLAN            2
extern romeCfgParam_t * pRomeCfgParam;

#ifdef	WIZARD
int wizard_go(u_char *dev)
#else
int wizard_go()
#endif
{
	int i, j, value = 0;
	int result = -1, wizard = -1, sockfd = 0;
	unsigned char *pptp_client="10.0.0.137";
	unsigned char *pptp_server_one="10.0.0.138";
	unsigned char *pptp_server_two="10.0.0.140";
	unsigned char argv[8][20];
	unsigned char *spoofMac; /*PCmac[20], _PCmac[12], mac[12], _mac[6],*/ 
	unsigned char cmd[50];
	
	pppoeDetected = 0;
	dhcpcDetected = 0;
	dhcp_type = 0;
	pptpDetected = 0;
	arpReply = 0;

	if (atoi(nvram_get("wan_mac_mode")) == 2)
		eth0_with_wan_mac_up(); //let wan0 becoming original mac address first just in case the spoofmac was already detected previously
	
	//if (argc<8) usage();
	//if (argc < 2) usage_pppoe();
	//DPRINTF("\nLet's go boy... :p\n\n");
	//FPRINTF(stderr, "\nLet's go boy... :p\n\n");
	
	//printf("%d = _sockfd = %d\n", __LINE__, _sockfd);
#if 0
	strcpy(PCmac, spoof_mac);
	
	j = 0;
	for ( i = 0; i < strlen(PCmac); i++) {
		if ( (i  !=  2) && (i  !=  5) && (i  !=  8) && ( i  !=  11) && ( i  !=  14)) {
			_PCmac[j] = PCmac[i];
			printf("* _PCmac[%d] = %c\n", j,  _PCmac[j]);
			j++;
		}
	}
	
	j = 0;
	for ( i = 0; i < 12; i++) {
		value = 0;
		sprintf(mac, "%c%c", _PCmac[i], _PCmac[i+1]);
		value = strtol(mac, NULL, 16);
		_mac[j++] = value;
		i++;
	}
#endif 

#ifdef	WIZARD
	char interface[50];
	sprintf(interface, "ifconfig %s 10.0.0.137 netmask 255.255.255.0", dev);
	printf("interface = %s\n", interface);
	system("interface");
	system("ifconfig eth0 10.0.0.137 netmask 255.255.255.0");
	strcpy(argv[1], dev);
#else
	system("ifconfig eth0 10.0.0.137 netmask 255.255.255.0");
	strcpy(argv[1], "eth0");
#endif

	for (cnt = 0; cnt < 3; cnt++) {
		strcpy(argv[6],pptp_client);
		strcpy(argv[8], pptp_server_one);
      		SendArpPkt(argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
      		//SendArpPkt(destMac);
      		DPRINTF("arpReply = %x\n", arpReply);
		if ( arpReply == 0x02 ) {
			arp_dest_ip = pptp_server_one;
      			memcpy(arp_dest_mac, argv[3], 6);
			DPRINTF("arp reply received\n");
			DPRINTF("destMac = ");
      			for(i=0; i<6; i++) DPRINTF("%02x ", arp_dest_mac[i]);
		} else
			arpReply = 0x00;
		printf("\n");
	}
#if 1	
       for (cnt = 0; cnt < 3; cnt++) {
		//SendArpPkt(argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
		SendpadiPkt(argv[1], argv[2], argv[3]);
		if ( pppoeDetected == 1 ) 
			break;
    		result = Senddhcpcpacket(argv[1], 0);
		if ( result > 0 )
			break;	
		/*result = -1;
		if ( result <= 0) {
			eth0_with_wan_spoofmac_up();
			result = Senddhcpcpacket(argv[1], 1);
			eth0_with_wan_mac_up();
			if ( result > 0 )
				break;
		} else
		break;*/
		//sleep(2);
    	}
#endif
	//result = -1;
	if ( result <= 0 && pppoeDetected == 0) {
		eth0_with_wan_spoofmac_up();
		for (cnt = 0; cnt < 3; cnt++) {
			result = Senddhcpcpacket(argv[1], 1);
			if ( result > 0 ) {
				//eth0_with_wan_mac_up();
				break;
			}
		}
		eth0_with_wan_mac_up();
	}
	
    	if ( pppoeDetected == 1 ) {
		printf("\n\n\n");	
		printf("PPPOE server is detected!\n\n");
		//system("echo 2 > /var/ptype.txt");
		//savePtype(2);
    		//exit(2);
    		return 2;
    	} else {
    		/* result = Senddhcpcpacket(argv[1], 0);	
		result = -1;
		if ( result <= 0 ) {
			eth0_with_wan_spoofmac_up();
			result = Senddhcpcpacket(argv[1], 1);
			eth0_with_wan_mac_up();
		}*/
		DPRINTF("result = %d\n", result);
		if (dhcpcDetected == 1) {
    			if ( dhcp_type/*result*/ == 10 ){
				printf("\n\n\n");	
				printf("DHCP offer received!\n\n");
    				return 1;
    			} else if ( dhcp_type/*result*/ == 20 ){
    				printf("\n\n\n");	
				printf("DHCP offer received and DNS domain option contains %s\\nn", DNS_SER_NAME); 
				return 5;
    			} else if ( dhcp_type/*result*/ == 30 ){	
				printf("\n\n\n");	
				printf("DHCP offer for spoofed mac received!\n\n");
				spoofMac = spoof_mac;
				printf("spoofMac = %s\n", spoofMac);
				nvram_set("wan_spoofmac", spoofMac);	
				//nvram_set("wizard_wan_spoofmac_detected", "1");
    				return 6;
    			} else if ( dhcp_type/*result*/ == 40 ){	
    				printf("\n\n\n");	
				printf("DHCP offer for spoofed mac received and DNS domain option contained %s\n\n", DNS_SER_NAME); 
				spoofMac = spoof_mac;
				printf("spoofMac = %s\n", spoofMac);
				nvram_set("wan_spoofmac", spoofMac);	
				//nvram_set("wizard_wan_spoofmac_detected", "1");	
				return 7;
    			}
		}
        }
    	
	printf("**********************************************************************\n");
	printf("no PPPOE and DHCP server were detected !\n\n");
	if( arpReply != 0x02) {
		for (cnt = 0; cnt < 3; cnt++) {
			strcpy(argv[6],pptp_client);
			strcpy(argv[8],pptp_server_two);
      			SendArpPkt(argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
      			//SendArpPkt(destMac);
			if ( arpReply == 0x02 ) {
				arp_dest_ip = pptp_server_two;
      			/*memcpy(arp_dest_mac, argv[3], 6);
			DPRINTF("arp reply received\n");
			DPRINTF("destMac = ");
      			for(i=0; i<6; i++) DPRINTF("%02x ", arp_dest_mac[i]);*/
			} else
				arpReply == 0x00;
		
			printf("\n");
		}
	}
    	if(/*pppoeDetected == 0 && dhcpcDetected == 0 && cnt > 2*/arpReply == 0x02 ) {
		result = Sendpptppacket(argv[1]); 
		if (result != -1) {
			printf("PPTP server is detected !\n");
			pptpDetected = 1;
			nvram_set("",arp_dest_ip);
			//system("echo 3 > /var/ptype.txt");
			//savePtype(3);
			//exit(3);
			return 3;
		} else {
			printf("no PPPOE, DHCP, PPTP servers were detected! Try static IP...\n");
			//system("echo 4 > /var/ptype.txt");
			//savePtype(4);
			//exit(4)
			return 4;
		}
		
    	}
    	printf("no PPTP server was detected! Try static IP...\n");
	//system("echo 4 > ptype.txt");
	//savePtype(4);
	/*{
		FILE *fp;
		int c;
		fp = fopen("ptype.txt", "r+");
		while((c = fgetc(fp)) != EOF)
			printf("%d\n\n", c);
		fclose(fp);
		system("rm ptype.txt");
	}*/
	//exit(4);
	return 4;
}

void savePtype(unsigned char ptype)
{
	FILE *fp;
	int c;
	
	fp=fopen("ptype.txt","w+");
	//printf("ptype = %d\n", ptype);
	
	if(fp) {
		c = fputc(ptype, fp);
		//printf("c = %d\n", c);
		fclose(fp);
	} else
		printf("file open failed \n");
}


void _die(char *str)
{
	FPRINTF(stderr, "\nAttention exit for the followent reason : %s\n", str);
	//exit(0);
	return;
}

int getdevindex(int sock, u_char *name)
{
	struct ifreq ifr;

	memset(&ifr, 0, sizeof(ifr));
	strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));

	if(ioctl(sock, SIOCGIFINDEX, &ifr) == -1) 
		_die("I can't get device flags...");
	FPRINTF(stderr, "Get ethernet flags...\n");
	DPRINTF("%s = %d\n", __FUNCTION__, ifr.ifr_ifindex);
	
	return ifr.ifr_ifindex;
}

void get_hw_addr(char *buf, char *str)
{
	int i;
	char c, val;

	for (i=0; i < ETH_ALEN; i++) {
		if (!(c=tolower(*str++))) _die("Invalid hardware address");
		if (isdigit(c)) val=c-'0';
		else if (c >= 'a' && c <= 'f') val = c-'a'+10;
		else _die("Invalid hardware address");
		*buf = val << 4;
		if (!(c=tolower(*str++))) _die("Invalid hardware address");
		if (isdigit(c)) val=c-'0';
		else if (c >= 'a' && c <= 'f') val = c-'a'+10;
		else _die("Invalid hardware address");
		*buf++ |= val;
		if (*str == ':') str++;
	}
}

int strip(unsigned char *dst, unsigned char *str)
{
	if (sscanf(str, "%d.%d.%d.%d", &dst[0], &dst[1], &dst[2], &dst[3]) == 4)
		return 0;
	return -1; 
			
}

#if 0
int scanport_arpping(unsigned char *yiaddr, unsigned char *lan_ip, unsigned char *lan_mac, unsigned char *dev,unsigned char *Target_mac)
{

	int	timeout = 2;
	int 	optval = 1;
	int	s;			/* socket */
	int	rv = 1;			/* return value */
	struct sockaddr addr;		/* for interface name */
	struct arpMsg	arp;
	fd_set		fdset;
	struct timeval	tm;
	time_t		prevTime;
	int i = 0;
	unsigned char targetIP[4], *arpReplyMac;
	
	DPRINTF("yiaddr = %s; lan_ip = %s; dev = %s; Target_mac = %s\n", yiaddr, lan_ip, dev, Target_mac);
	DPRINTF("%02x %02x %02x %02x %02x %02x\n", lan_mac[0], lan_mac[1], lan_mac[2], lan_mac[3], lan_mac[4], lan_mac[5]);
	
	if ((s = socket (PF_PACKET, SOCK_PACKET, htons(ETH_P_ARP))) == -1) {
		printf( "Could not open raw socket\n");
		return -1;
	}
	
	if (setsockopt(s, SOL_SOCKET, SO_BROADCAST, &optval, sizeof(optval)) == -1) {
//		cprintf(LOG_ERR, "Could not setsocketopt on raw socket");
		printf( "Could not setsocketopt on raw socket\n");
		close(s);
		return -1;
	}

	/* send arp request */
	memset(&arp, 0, sizeof(arp));
	memcpy(arp.ethhdr.h_dest, MAC_BCAST_ADDR, 6);	/* MAC DA */
	memcpy(arp.ethhdr.h_source, lan_mac, 6);		/* MAC SA */
	arp.ethhdr.h_proto = htons(ETH_P_ARP);		/* protocol type (Ethernet) */
	arp.htype = htons(ARPHRD_ETHER);		/* hardware type */
	arp.ptype = htons(ETH_P_IP);			/* protocol type (ARP message) */
	arp.hlen = 6;					/* hardware address length */
	arp.plen = 4;					/* protocol address length */
	arp.operation = htons(ARPOP_REQUEST);		/* ARP op code */
	inet_aton(lan_ip, arp.sInaddr);
	inet_aton(yiaddr, arp.tInaddr);
	//*((u_int *) arp.sInaddr) = ip;			/* source IP address */
	memcpy(arp.sHaddr, lan_mac, 6);			/* source hardware address */
	//*((u_int *) arp.tInaddr) = yiaddr;		/* target IP address */
	
	memset(&addr, 0, sizeof(addr));
	strncpy(addr.sa_data, dev, 4);
	if (sendto(s, &arp, sizeof(arp), 0, &addr, sizeof(addr)) < 0) {
		rv = 0;
		printf("%s: sendto error!\n", __FUNCTION__);
	}
	
#ifdef  SCANPORT_DEBUG
	DPRINTF("sending arp reply ... \n");
	for (i = 0; i < sizeof(arp); i++) {
		unsigned char *ptr;

		ptr = (unsigned char *)&arp;
		DPRINTF("%02x ", ptr[i]);
	}
#endif

	/* wait arp reply, and check it */
	tm.tv_usec = 0;
	time(&prevTime);
	
	while (timeout > 0) {  
		FD_ZERO(&fdset);
		FD_SET(s, &fdset);
		tm.tv_sec = timeout;
		if (select(s + 1, &fdset, (fd_set *) NULL, (fd_set *) NULL, &tm) == -1) {
		//if (select(s+1, &fdset, NULL, NULL, &tm) < 1) {
			//fprintf(LOG_ERR, "Error on ARPING request: %s", strerror(errno));
			if (errno != EINTR) rv = 0;
			printf("%s: Error on ARPING request\n", __FUNCTION__);
			//return;
		} else if (FD_ISSET(s, &fdset)) {
			if (recv(s, &arp, sizeof(arp), 0) < 0 ) {
				rv = 0;
				printf("%s: recv error !\n", __FUNCTION__);
				//return;
			}
			
#ifdef  SCANPORT_DEBUG
			
			DPRINTF("received arp reply ..\n");
			for (i = 0; i < sizeof(arp); i++) {
				unsigned char *ptr;

				ptr = (unsigned char *)&arp;
				DPRINTF("%02x ", ptr[i]);
			}

			DPRINTF("lan_mac %02x %02x %02x %02x %02x %02x\n", lan_mac[0], lan_mac[1], lan_mac[2], lan_mac[3], lan_mac[4], lan_mac[5]);
			DPRINTF("arp.tHaddr %02x %02x %02x %02x %02x %02x\n", arp.tHaddr[0], arp.tHaddr[1], arp.tHaddr[2], arp.tHaddr[3], arp.tHaddr[4], arp.tHaddr[5]);
			DPRINTF("arp.operation %02x\n", arp.operation);
			DPRINTF("arp.sInaddr %d %d %d %d\n", arp.sInaddr[0], arp.sInaddr[1], arp.sInaddr[2], arp.sInaddr[3]);
			DPRINTF("devIP %d %d %d %d\n", targetIP[0], targetIP[1], targetIP[2], targetIP[3]);
#endif

			inet_aton(yiaddr, targetIP);
			if (arp.operation == htons(ARPOP_REPLY) && memcmp(arp.tHaddr, lan_mac, 6) == 0 &&  memcmp(arp.sInaddr, targetIP, 4) == 0) {
				//fprintf(LOG_INFO, "Valid arp reply receved for this address");
				memcpy(scan_dst_hw, arp.sHaddr, ETH_ALEN);
				memcpy(scan_dst_ip, arp.sInaddr, 4);
				DPRINTF("Valid arp reply receved for this address\n");
				rv = 0;
				break;
			}
		}
		timeout -= time(NULL) - prevTime;
		time(&prevTime);
	}
	close(s);
	if (rv==0){
		if (Target_mac != NULL){
			sprintf(arpReplyMac, "%02x:%02x:%02x:%02x:%02x:%02x", arp.sHaddr[0], arp.sHaddr[1], arp.sHaddr[2], arp.sHaddr[3], arp.sHaddr[4], arp.sHaddr[5]);
			
			for ( i = 0; i < strlen(arpReplyMac); i++ ) 
				arpReplyMac[i] = toupper(arpReplyMac[i]);
			
			DPRINTF("arpReplyMac = %s\n", arpReplyMac);
			//if(memcmp(arp.sHaddr,Target_mac,6)){
			if(strncmp(arpReplyMac,Target_mac,strlen(arpReplyMac))){	
				DPRINTF("************************\n");
				rv=1;
			}
		} else
			rv=1;
	}
	DPRINTF("rv = %d\n", rv);
//	cprintf(LOG_INFO, "%salid arp replies for this address", rv ? "No v" : "V");
	printf("%salid arp replies for this address %s\n\n", rv ? "No v" : "V", yiaddr);
	return rv;
}
#endif

int SendArpPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw, u_char *op, u_char *src_a_hw, u_char *src_a_ip, u_char *dst_a_hw, u_char *dst_a_ip)
{
	struct sockaddr_ll to;
	struct sockaddr_ll sock_fd;
	ARP_PACKET pkt;
	ARP_PACKET rcvpkt;
	int sock;
	struct ifreq ifr;
	int i, bytes;
	struct timeval tm; 
	int timeout = 1;
	time_t		prevTime;
	fd_set in;
		
	if ((sock = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		_die("Can't create socket...");
	
	memset(&ifr, 0, sizeof(ifr));
	ifr.ifr_addr.sa_family = AF_INET;
	//strcpy(dev, "eth0");
	if (ioctl(sock, SIOCGIFINDEX, &ifr) == 0) 
		DPRINTF("ifr.ifr_ifindex = %d\n", ifr.ifr_ifindex);
		
	//ifr.ifr_ifindex = 2;
	if (ioctl(sock, SIOCGIFNAME, &ifr) == 0)
		DPRINTF("ifr.ifr_name = %s\n", ifr.ifr_name);
	
	close(sock);
	
	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) == -1)
		_die("Can't create socket");
	
	
	if ((to.sll_ifindex = getdevindex(sock, dev)) == -1) {
		close(sock);
		_die("Can't get interface");
	}

	  memset(&ifr, 0, sizeof(ifr));
	  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
	  ifr.ifr_ifindex = to.sll_ifindex;

  	if(ioctl(sock, SIOCGIFHWADDR, &ifr) == -1) {
		close(sock);
	    	_die("I can't get device hw addr...");
  	}
	  
	  memcpy(sock_fd.sll_addr, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
	  
	/* Eth header */
	memcpy(pkt.Src_e_hw, sock_fd.sll_addr, ETH_ALEN);
#define DST_MAC_ADDR 	((unsigned char *)("\xff\xff\xff\xff\xff\xff"))	
	memcpy(pkt.Dst_e_hw, DST_MAC_ADDR, ETH_ALEN);
	pkt.frame_type = htons(ETH_P_ARP);
	FPRINTF(stderr, "Eth header is ready...\n");
	
	/* arp */
#define ARPHDR_ETHER		0x01
	pkt.hw_type = htons(ARPHDR_ETHER);
	pkt.prot_type = htons(ETH_P_IP);
	pkt.hw_addr_size = ETH_ALEN;
	pkt.prot_addr_size = 4;
	//pkt.op = htons(op);
	pkt.op = htons(0x01);
	FPRINTF(stderr, "Arp header is ready...\n");
	/* data */
	//get_hw_addr(pkt.Src_a_hw, src_a_hw);
	//get_hw_addr(pkt.Dst_a_hw, dst_a_hw);
	if (*src_a_ip == NULL)
		strcpy(src_a_ip, "10.0.0.137");
	//if(*dst_a_ip == NULL)
		//dst_a_ip = "10.0.0.138";
	
	inet_aton(src_a_ip, pkt.Src_a_ip);
	inet_aton(dst_a_ip, pkt.Dst_a_ip);
	DPRINTF("src_a_ip = %d.%d.%d.%d\n", pkt.Src_a_ip[0], pkt.Src_a_ip[1], pkt.Src_a_ip[2], pkt.Src_a_ip[3]);
	DPRINTF("dst_a_ip = %d.%d.%d.%d\n", pkt.Dst_a_ip[0], pkt.Dst_a_ip[1],pkt.Dst_a_ip[2],pkt.Dst_a_ip[3]);
	//get_hw_addr(pkt.Src_a_hw, src_a_hw);
	memcpy(pkt.Src_a_hw, pkt.Src_e_hw, ETH_ALEN);
	//get_hw_addr(pkt.Dst_a_hw, dst_a_hw);
	memcpy(pkt.Dst_a_hw, DST_MAC_ADDR, ETH_ALEN);
	/* write and send */

#ifdef	WIZARD_DEBUG
	for (i = 0; i < sizeof(pkt); i++) {
		unsigned char *ptr;

		ptr = (unsigned char *)&pkt;
		DPRINTF("%02x ", ptr[i]);
	}
	DPRINTF("\n");
#endif

	if (sendto(sock, &pkt, sizeof(pkt), 0, (struct sockaddr *)&to, sizeof(to)) < 0) {
		close(sock);
		_die("I can't send pkt");
	}
	FPRINTF(stderr, "The ARP packet is send. The matrix is around you!\n");
	//close(sock);



	tm.tv_usec = 0;		
	time(&prevTime);
	while (timeout > 0) {
		FD_ZERO(&in);
		FD_SET(sock, &in);
		tm.tv_sec = timeout; /* wait 1 sec */
		if ( select(sock+1, &in, NULL, NULL, &tm) < 0)
			goto check_timeout;
		else if (FD_ISSET(sock, &in)) {
			memset(&rcvpkt, 0, sizeof(rcvpkt));
			bytes = read(sock, &rcvpkt, sizeof(rcvpkt));

			if (bytes < 0) {
				goto check_timeout;
			}

			u_char *ptr;
			ptr = (unsigned char *)&rcvpkt;
			DPRINTF("arp reply : %02x\n", rcvpkt.op);
	      		if ((memcmp(pkt.Src_a_hw/*Dst_a_hw*/, &ptr[0], ETH_ALEN) == 0) && (ntohs(rcvpkt.frame_type) == 0x0806) && (rcvpkt.op == 0x02)) {
	      			arpReply = rcvpkt.op/*ptr[21]*/;
			    	//DPRINTF("arp reply : %02x\n", ptr[22]);
			    	DPRINTF("recv ARP reply from  %d.%d.%d.%d\n", pkt.Src_a_ip[0], pkt.Src_a_ip[1], pkt.Src_a_ip[2], pkt.Src_a_ip[3]);
	
#ifdef	WIZARD_DEBUG			    	
			    	for (i = 0; i < bytes; i++) {
			      		DPRINTF("%02x ", ptr[i]);
			    	}
			    	DPRINTF("\n");
#endif				
				break;
			}	
		}
		
check_timeout:
		timeout -= time(NULL) - prevTime;
		time(&prevTime);
	}
	
	close(sock);
	
	return 0;
	          
}


void SendpadiPkt(u_char *dev, u_char *src_e_hw, u_char *dst_e_hw)
{
	struct sockaddr_ll to;
	struct sockaddr_ll sock_fd;
	PADI_PACKET pkt;
	int sock;
	struct ifreq ifr;
	int i;
	unsigned char packet[100];
	int bytes = 0;
	int timeout = 1;
	time_t	prevTime;
	struct timeval tm;
	fd_set in;

	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) == -1)
	//if ((sock = socket(PF_PACKET, SOCK_RAW, htons(0x8863))) == -1)
		_die("Can't create socket");

	if ((to.sll_ifindex = getdevindex(sock, dev)) == -1) {
		close(sock);
		_die("Can't get interface");
	}

	  memset(&ifr, 0, sizeof(ifr));
	  strncpy(ifr.ifr_name, dev, sizeof(ifr.ifr_name));
	  ifr.ifr_ifindex = to.sll_ifindex;

  	if(ioctl(sock, SIOCGIFHWADDR, &ifr) == -1) {
		close(sock);
	    	_die("I can't get device hw addr...");
  	}
	  
	  memcpy(sock_fd.sll_addr, ifr.ifr_hwaddr.sa_data, ETH_ALEN);
		
		

	/* bind */
	sock_fd.sll_family = AF_PACKET;
	//sock_fd.sll_protocol = htons(0x0);
	sock_fd.sll_protocol = ntohs(ETH_P_PPP_DISC);
	sock_fd.sll_hatype = ARPHRD_ETHER;
	sock_fd.sll_pkttype = PACKET_BROADCAST;
	sock_fd.sll_ifindex = to.sll_ifindex;
//#define SRC_MAC_ADDR 	((unsigned char *)("\x00\x06\x1b\xd0\xaf\xdb"))	
#define DST_MAC_ADDR 	((unsigned char *)("\xff\xff\xff\xff\xff\xff"))	
	//memcpy(sock_fd.sll_addr, MAC_ADDR, ETH_ALEN);
	if (bind(sock, (struct sockaddr *)&sock_fd, sizeof(sock_fd)) < 0) {
		close(sock);
		_die("bind call failed");
	}
	
	/* Eth header */
	//get_hw_addr(pkt.Src_e_hw, src_e_hw);
	memcpy(pkt.Src_e_hw, sock_fd.sll_addr, ETH_ALEN);
	//get_hw_addr(pkt.Dst_e_hw, dst_e_hw);
	memcpy(pkt.Dst_e_hw, DST_MAC_ADDR, ETH_ALEN);
	pkt.frame_type = htons(ETH_P_PPP_DISC);
	FPRINTF(stderr, "Eth header is ready...\n");
	
	pkt.v_t = 0x11;
	pkt.code = 0x09;
	pkt.session_id = htons(0x0);
	pkt.len = htons(0x04);
	pkt.tag_type = htons(0x0101);
	pkt.tag_len = htons(0x0);

  	if (sendto(sock, &pkt, sizeof(pkt), 0, (struct sockaddr *)&to, sizeof(to)) < 0) {
		close(sock);
		_die("I can't send pkt");
  	}
	/* write and send */
#ifdef	WIZARD_DEBUG
  	for (i = 0; i < sizeof(pkt); i++) {
  	  	unsigned char *ptr;

	  	ptr = (unsigned char *)&pkt;
	  	DPRINTF("%02x ", ptr[i]);
  	}
  	DPRINTF("\n");
  	FPRINTF(stderr, "The PADI packet is send. The matrix is around you!\n");
#endif 	
	
    	tm.tv_usec = 0;		
    	time(&prevTime);

	while(timeout > 0) {
	    	FD_ZERO(&in);
	    	FD_SET(sock, &in);
	    	tm.tv_sec = timeout;	/* wait 1 sec */
	   	if ( select(sock+1, &in, NULL, NULL, &tm) < 0 ){
	   		pppoeDetected = 0;
			goto check_padi_timeout;
	   	} else if(FD_ISSET(sock, &in)) {
	      		bytes = read(sock, &packet, sizeof(packet));
			if (bytes < 0){
				pppoeDetected = 0;
				goto check_padi_timeout;
			}
				
#ifdef	WIZARD_DEBUG
			for (i = 0; i < sizeof(packet); i++) {
			  	unsigned char *ptr;
	
				ptr = (unsigned char *)&packet;
				printf("%02x ", ptr[i]);
		    	}
			printf("\n");
		  
			unsigned short rcvd_packet;
			rcvd_packet = ntohs(*(unsigned short *)(packet+12));
			printf("%s rcvd_packet = 0x%4x\n", __FUNCTION__, rcvd_packet);
#endif 	
	      		if ((ntohs(*((unsigned short *)(packet+12))) == 0x8863) && (packet[15] == 0x07)) {
		    		pppoeDetected = 1;
		    		printf("recv 0x8863 Discovery stage PADO \n");		  
		    		break;
	         	} else {
	          		pppoeDetected = 0;
				goto check_padi_timeout;
	         	}
		}  
					
check_padi_timeout:
		timeout -= time(NULL) - prevTime;
		time(&prevTime);
	    }		
	
	close(sock);

}

unsigned char * 
wizard_get_http_client_hwaddr(unsigned char *ip)
{
	FILE *fp;
        unsigned char line[100];
	unsigned char ipa[50];           // ip address
	unsigned char hwa[50];           // HW address 
	unsigned char mask[50];          // ntemask   
	unsigned char dev[50];           // interface
	int type;               // HW type
	int flags;              // flags
	unsigned char mac[20]; 

	
	memset(mac,0,20);	
       if ((fp = fopen("/proc/net/arp", "r")) == NULL) 
		return NULL;
        	
        
	// Read the ARP cache entries.
	// IP address       HW type     Flags       HW address            Mask     Device
	// 192.168.2.1      0x1         0x2         xx:xx:xx:xx:xx:xx     *          br0
	while( fgets(line, sizeof(line), fp)!=NULL)
	{
		if(sscanf(line, "%s 0x%x 0x%x %s %s %s\n", ipa, &type, &flags, hwa, mask, dev) != 6)
			continue;
			
		if(strcmp(ip, ipa)) 
			continue;
		else {
			strcpy(mac, hwa);
			//printf("ip = %s; mac = %s\n", ip, mac);
			break;
		}
				
	}
	/* for check MAC not found, default WAN mac address */
	//if (strcmp("eth0", dev))
		 //strcpy(mac,nvram_get("wan0_hwaddr"));

	fclose(fp);
	//printf("%d = mac = %s\n", __LINE__, mac);
	return mac;
}

unsigned char *
wizard_getclonemac(int sock)
{
	//char zero_mac[20];
	unsigned char str_clientip[20];
	unsigned char str_mac[20];
	struct sockaddr_in peer;
	int    peer_len=sizeof(peer);
	int ret = 0;
	int foundIP = 0;

	memset(str_mac, 0, 20);
	//printf("%d = sock = %d\n", __LINE__, sock);
	if (getpeername(sock,(struct sockaddr*)&peer,&peer_len ) < 0) {
		printf("Can't get remote address and port\n");
		return ret;
	}
	
	strcpy(str_clientip, inet_ntoa(peer.sin_addr));
	//printf("str_clientip = %s\n", str_clientip);
	strcpy(str_mac, wizard_get_http_client_hwaddr(str_clientip));
	//printf("xxx\n");
	//printf("str_mac = %s\n", str_mac);
	
	
	if ( str_mac )
		return str_mac;
	else
		return NULL;

}

void
eth0_with_wan_mac_up(void)
{
	char cmd[50];
	char wan_mac[17];
	char macstr[17];
	int i;

	if (atoi(nvram_get("wan_mac_mode")) == 2) {
		strcpy(wan_mac, nvram_get("lan_hwaddr")/*nvram_get("wan0_hwaddr")*/); //get lan mac just in case the wan0_hwaddr was modified as spoofmac previously
		wan_mac[16] += 1;
	} 
	else
		strcpy(wan_mac, nvram_get("wan0_hwaddr"));

	printf("wan_mac = %s\n", wan_mac);
	ether_atoe(wan_mac, macstr);
	
	re865xIoctl("eth0",ADD_VLAN,pRomeCfgParam->vlanCfgParam[0].vid,
								    pRomeCfgParam->vlanCfgParam[0].memberPort,
								    (uint32)&macstr);
	system("ifconfig eth0 down");
	sprintf(cmd, "ifconfig eth0 hw ether %s", wan_mac/*nvram_get("wan0_hwaddr")*/); 
	printf("cmd = %s\n", cmd);
	system(cmd);
	system("ifconfig eth0 up");
}

void
eth0_with_wan_spoofmac_up(void)
{
	char cmd[50];
	char macstr[17];
	
	ether_atoe(spoof_mac, macstr);
	re865xIoctl("eth0",ADD_VLAN,pRomeCfgParam->vlanCfgParam[0].vid,
								    pRomeCfgParam->vlanCfgParam[0].memberPort,
								    (uint32)&macstr);
	system("ifconfig eth0 down");
	sprintf(cmd, "ifconfig eth0 hw ether %s", spoof_mac); 
	printf("cmd = %s\n", cmd);
	system(cmd);
	system("ifconfig eth0 up");
}
